#ifndef _ETHERNET_H
#define _ETHERNET_H
/*
	$Author: me $ - $Date: 1999/03/21 04:04:01 $
*/
/*----------------------------------------------------------------------------------------
	NAT
------------------------------------------------------------------------------------------*/
// Network Address Translation for the BeOS
// Richard Burgess <rickb@spy.net>

/*----------------------------------------------------------------------------------------
	Ethernet
------------------------------------------------------------------------------------------*/
// RFC 894
// functions to manipulate Ethernet Packets

// ethernet defines
#define	ETHERNET_ADDR_LEN			6
#define ETHERNET_MAX_LEN      		1536

// protocols (defined in network byte order)
#define ETHERNET_PROTOID_IP      	0x0800
#define ETHERNET_PROTOID_ARP       	0x0806
#define ETHERNET_PROTOID_RARP		0x8035
#define ETHERNET_PROTOID_APLTK      0x809b

// header offsets, our preferred way to access header elements
#define ETHERNET_DST_ADDR_OFFSET	0
#define ETHERNET_SRC_ADDR_OFFSET	6
#define ETHERNET_PROTOCOL_OFFSET	12
#define ETHERNET_HEADER_LENGTH		14

// ethernet header
// be sure to take into account endianess and alignment issues 
// if you use these structs to read and write to datagrams.

#pragma align=packed
struct ether_addr {
	uint8 octet[ETHERNET_ADDR_LEN];
};

struct ethernet_header
{
	ether_addr	dst;	// destination ethernet address
	ether_addr	src;	// source ethernet address
	uint16		type;	// protocol type
};

struct ethernet_trailer
{
	int32 check_sum;
};
#pragma align=reset

#endif
