#ifndef _PROTOCOLS_H
#define _PROTOCOLS_H
/*
	$Author: me $ - $Date: 1999/03/21 04:04:02 $
*/
/*----------------------------------------------------------------------------------------
	 NAT
------------------------------------------------------------------------------------------*/
// Network Address Translation for the BeOS
// Richard Burgess <rickb@spy.net>

// return true if it handles the protocol
// functions need to modify checksum
// based on the changes they make to the packet
// packet is set to the end of the tcp/udp header

typedef bool (*nat_translate_packet)(BNetPacket*, uint16* checksum, 
									 uint32 orig_addr, uint32 new_addr,
									 uint16 orig_port, uint16 new_port);
									 
struct nat_protocol
{
	char name[32];
	nat_translate_packet	in_translate_packet;
	nat_translate_packet	out_translate_packet;
};

// adjust that pesky checksum
extern void checksum_adjust(uint8* chksum, uint8 *optr, int32 olen, uint8 *nptr, int32 nlen);

#endif