#ifndef _TCP_H
#define _TCP_H
/*
	$Author: me $ - $Date: 1999/04/02 23:51:10 $
*/
/*----------------------------------------------------------------------------------------
	 NAT
------------------------------------------------------------------------------------------*/
// Network Address Translation for the BeOS
// Richard Burgess <rickb@spy.net>

/*----------------------------------------------------------------------------------------
	 TCP Header
------------------------------------------------------------------------------------------*/
//	RFC 793
//	be sure to take into account endianess and alignment issues 
//	if you use these structs to read and write to datagrams.
#pragma align=packed
struct tcp_header 
{
	uint16	src_port;		// source port
	uint16 	dst_port;		// destination port
	int32	seq_num;		// sequence number
	int32	ack_num;		// acknowledgement number
#if B_HOST_IS_BENDIAN
	uint8	offset:4,		// offset
			reserved:4;		// reserved
#else
	uint8	reserved:4,		// reserved
			offset:4;		// offset
#endif
	uint8	flags;			// flags
	uint16 	window;			// window
	uint16 	checksum;		// checksum
	uint16	urgent;			// urgent pointer
};
#pragma align=reset

// header offsets, our preferred way to access header elements
#define TCP_SRC_PORT_OFFSET	0
#define TCP_DST_PORT_OFFSET	2
#define TCP_SEQ_NUM_OFFSET	4
#define TCP_ACK_NUM_OFFSET	8
#define TCP_OFFSET_OFFSET	12
#define TCP_FLAGS_OFFSET	13
#define TCP_WINDOW_OFFSET	14
#define TCP_CHECKSUM_OFFSET	16
#define TCP_URGENT_OFFSET	18
#define TCP_HEADER_SIZE		20

#define FIN_MASK 0x1

// accessors (on net-ordered data)
#define TCP_OFFSET(x) 	(x >> 4)

#endif